import greenfoot.*;  

public class Bola extends Actor
{
    private int rx=0,ry=0,L=0;
    private double theta=0,thetao=0,dt=0.5;
    private boolean drag;
    public Point point=null;
    public Wire wire=null;
    
    private void move()
    {
        double theta2=2*theta-thetao+10.0*dt*dt*Math.sin(theta)/L;
        
        int posx=point.getX()+(int)(L*Math.cos(theta2-0.5*Math.PI));
        int posy=point.getY()+(int)(L*Math.sin(theta2-0.5*Math.PI));
        
        thetao=theta;
        theta=theta2;
        
        setLocation(posx,posy);
        wire.update();
    }
    
    public void pertama()
    {
        int xo=0,yo=0,x=0,y=0;
 
        if(point!=null){
            xo=point.getX();
            yo=point.getY();
        }
        
        x=getX();
        y=getY();
        
        int rxo=x-xo;
        int ryo=y-yo;
        theta=Math.atan2(ryo,rxo)+0.5*Math.PI;
        thetao=theta;
        
        L=(int)Math.sqrt(rxo*rxo+ryo*ryo);
    }
    
    public void act() 
    {
        if(Greenfoot.mouseDragged(this)){
            MouseInfo mouse=Greenfoot.getMouseInfo();
            if(!drag){
                drag=true;
                rx=mouse.getX()-getX();
                ry=mouse.getY()-getY();
            }
            
            if(drag){
                setLocation(mouse.getX()-rx,mouse.getY()-ry);
                wire.update();
            }
        }
        
        if(Greenfoot.mouseDragEnded(this)){
            drag=false;
            pertama();
        }
        
        if(!drag)move();
    }    
}
